//+------------------------------------------------------------------+
//|                                                   Asiwaju.mq4 |
//|                      Copyright  2010, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

//----Settings
extern int       period=20;
extern int       method=3;
extern int       price=0;
extern int       BandsPeriod=14;
extern double       BandsDeviations=1.0;
extern int Takeprofit = 2000;
extern int Stoploss   = 1000;
extern int TrailingStop  = 1;
extern double Lots          = 0.01;
extern int    Magicnumber   = 11;
extern int    OrderSlippage = 3;
extern bool   TimeOption    = false;
extern string TimeBeginEnd = "06:00 - 18:00";
double OrderAngaben[20];
double geteiltdurch;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
 if(Digits==2)geteiltdurch=100.0;
 if(Digits==3)geteiltdurch=100.0;
 if(Digits==4)geteiltdurch=10000.0;
 if(Digits==5)geteiltdurch=10000.0;
 return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----



//+------------------------------------------------------------------+
//|           Handelszeit berprfen                                 |
//+------------------------------------------------------------------+
if(TimeOption)
{
   int begin = StringFind(TimeBeginEnd, ":")+1; 
   int end = StringFind(TimeBeginEnd, ":", begin);
   int zwei = StrToInteger(StringSubstr(TimeBeginEnd, begin, end-begin));  
   begin = end+1;
   end = StringFind(TimeBeginEnd, ":", begin);
   begin = end+1; 
   end = StringFind(TimeBeginEnd, ":", begin); 
   int eins = StrToInteger(StringSubstr(TimeBeginEnd, begin, end-begin)); 
   begin = end+1; 
   end = StringFind(TimeBeginEnd, "-", begin); 
   begin = end+1; 
   end = StringFind(TimeBeginEnd, ":", begin);    
   int drei = StrToDouble(StringSubstr(TimeBeginEnd, begin, end-begin)); 
   begin = end+1; 
   end = StringFind(TimeBeginEnd, ":", begin);    
   int vier = StrToDouble(StringSubstr(TimeBeginEnd, begin, end-begin)); 
   int Anfang=StrToTime(DoubleToStr(TimeYear(Time[0]),0)+"."+DoubleToStr(TimeMonth(Time[0]),0)+"."+DoubleToStr(TimeDay(Time[0]),0)+" "+DoubleToStr(eins,0)+":"+DoubleToStr(zwei,0));
   int Ende=StrToTime(DoubleToStr(TimeYear(Time[0]),0)+"."+DoubleToStr(TimeMonth(Time[0]),0)+"."+DoubleToStr(TimeDay(Time[0]),0)+" "+DoubleToStr(drei,0)+":"+DoubleToStr(vier,0));
   if(Anfang<Ende)
   {
    if(Time[0]>Anfang && Time[0]<Ende) int traden=1; else traden=0;
   }
   else if(Anfang>Ende)
   {
    if((TimeHour(Time[0]) == eins && TimeMinute(Time[0]) >= zwei) || (TimeHour(Time[0])<drei) || (TimeHour(Time[0]) == drei && TimeMinute(Time[0]) < vier))  traden=1; else traden=0;
   }
}
else traden=1;





//----Open Orderangaben
Orders();





//----Indicator
int signal=0;
double macd1=iMACD(NULL,0,12,26,9,PRICE_CLOSE,MODE_MAIN,1);
double macd2=iMACD(NULL,0,12,26,9,PRICE_CLOSE,MODE_SIGNAL,1);
double macd3=iMACD(NULL,0,12,26,9,PRICE_CLOSE,MODE_MAIN,3);
double ma1=iMA(NULL,0,20,0,MODE_SMA,PRICE_CLOSE,1)-iMA(NULL,0,20,0,MODE_SMA,PRICE_OPEN,1);
double ma2=iMA(NULL,0,20,0,MODE_SMA,PRICE_OPEN,1)-iMA(NULL,0,20,0,MODE_SMA,PRICE_CLOSE,1);
double MA1=iMA(NULL,0,20,0,MODE_SMA,PRICE_CLOSE,2)-iMA(NULL,0,20,0,MODE_SMA,PRICE_OPEN,2);
double MA2=iMA(NULL,0,20,0,MODE_SMA,PRICE_OPEN,2)-iMA(NULL,0,20,0,MODE_SMA,PRICE_CLOSE,2);
double sar=iSAR(NULL,0,0.02,0.2,0);
double bb1=iMA(NULL,0,20,0,MODE_SMA,PRICE_CLOSE,1);
double STOCH1=iStochastic(NULL,0,5,3,3,MODE_SMA,0,MODE_MAIN,1);
double STOCHA1=iStochastic(NULL,0,5,3,3,MODE_SMA,0,MODE_MAIN,2);
double STOCH2=iStochastic(NULL,0,5,3,3,MODE_SMA,0,MODE_SIGNAL,1);
double STOCHA2=iStochastic(NULL,0,5,3,3,MODE_SMA,0,MODE_SIGNAL,2);
double stoch1=iStochastic(NULL,0,5,3,3,MODE_SMA,0,MODE_MAIN,0);
double stocha1=iStochastic(NULL,0,14,3,3,MODE_SMA,0,MODE_MAIN,2);
double stoch2=iStochastic(NULL,0,5,3,3,MODE_SMA,0,MODE_SIGNAL,0);
double stocha2=iStochastic(NULL,0,14,3,3,MODE_SMA,0,MODE_SIGNAL,2);
double val1=iCustom(Symbol(),0,"Val_Bands",BandsPeriod,BandsDeviations,1,1);
double val2=iCustom(Symbol(),0,"Val_Bands",BandsPeriod,BandsDeviations,3,1);
double wert1=iCustom(Symbol(),0,"SDL_MAM",period,method,price,0,1);
double wert2=iCustom(Symbol(),0,"SDL_MAM",period,method,price,0,2);
double wert3=iCustom(Symbol(),0,"SDL_MAM",period,method,price,1,1);
double wert4=iCustom(Symbol(),0,"SDL_MAM",period,method,price,1,2);
if(wert1!=EMPTY_VALUE && wert1>wert2)signal=1;
if(wert3!=EMPTY_VALUE && wert3<wert4)signal=2;





//----Entry
if(traden==1 && signal==1 && OrderAngaben[2]<=0 && ma1>ma2 && macd1>macd2 && val1>val2 && ((STOCH1>STOCH2 && STOCHA1<=STOCHA2 && Close[0]<High[1]) || (STOCH1<=STOCH2 && stoch1>stoch2 && High[0]>=High[1])) && Low[0]>Low[1] && Open[1]<Close[1] && STOCH1<80) 
CheckForOpen(OP_BUY, Lots, "EA", Magicnumber);
if(traden==1 && signal==2 && OrderAngaben[2]<=0 && ma1<ma2 && macd1<macd2 && val1>val2 && ((STOCH1<STOCH2 && STOCHA1>=STOCHA2 && Close[0]>Low[1]) || (STOCH1>=STOCH2 && stoch1<stoch2 && Low[0]<=Low[1])) && High[0]<High[1] && Open[1]>Close[1] && STOCH1>20) 
CheckForOpen(OP_SELL, Lots, "EA", Magicnumber);



//----Exit
if(signal==2 || Open[1]>Close[1] || Low[0]<=Low[1] || val1<=val2)CheckForClose(OrderAngaben[2], OP_BUY);
if(signal==1 || Open[1]<Close[1] || High[0]>=High[1] || val1<=val2)CheckForClose(OrderAngaben[2], OP_SELL);



//----Takeprofit and Stoploss
if(OrderAngaben[2]>0)SLTKNachreichen(Takeprofit, Stoploss);



//----Traillingtop
if(TrailingStop > 0)TrailingPositions(TrailingStop);


//----
   return(0);
  }
//+------------------------------------------------------------------+




//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

void Orders()
{
//----
ArrayInitialize(OrderAngaben,0);
for(int i=0; i <= OrdersTotal(); i++)
{
 if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==true)
 {
  if(OrderMagicNumber()==Magicnumber)
   {
    if(OrderType()==OP_BUY)
     {
      OrderAngaben[0]=OrderAngaben[0]+1;
      OrderAngaben[2]=OrderAngaben[2]+1;
      OrderAngaben[3]+=MarketInfo(Symbol(),MODE_BID)-OrderOpenPrice();
      OrderAngaben[5]+=NormalizeDouble(OrderLots(),MarketInfo(Symbol(),MODE_DIGITS));
      OrderAngaben[7]=OrderOpenPrice();
      OrderAngaben[10]+=OrderProfit();
     }
    if(OrderType()==OP_SELL)
     {
      OrderAngaben[1]=OrderAngaben[1]+1;
      OrderAngaben[2]=OrderAngaben[2]+1;
      OrderAngaben[3]+=OrderOpenPrice()-MarketInfo(Symbol(),MODE_ASK);
      OrderAngaben[6]+=NormalizeDouble(OrderLots(),MarketInfo(Symbol(),MODE_DIGITS));
      OrderAngaben[8]=OrderOpenPrice();
      OrderAngaben[10]+=OrderProfit();
     }
    }
   }
  }
return;
//----
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void TrailingPositions(int TrailingStop)
{
//----
for(int cnt=0; cnt < OrdersTotal(); cnt++)
{
 //----
 if(OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES))
  {
   if(OrderType()<=OP_SELL && OrderSymbol()==Symbol() && OrderMagicNumber()==Magicnumber)
    {
     if(OrderType()==OP_BUY && TrailingStop>0)
      {
       if(Close[0]>Low[1])
        {
         if(Low[1]>Low[2])
          {
           OrderModify(OrderTicket(),OrderOpenPrice(),Low[1],OrderTakeProfit(),0,Green);
           int err = GetLastError();
           if(err != 0)Print("Trailingstop Error modiy Buyorder error #",err);
           return(0);
          }
         }
        }
        else if(TrailingStop>0)
         {
          if(High[1]>Close[0])
           {
            if(High[1]<High[2])
            {
             OrderModify(OrderTicket(),OrderOpenPrice(),High[1],OrderTakeProfit(),0,Red);
             err = GetLastError();
             if(err != 0)Print("Trailingstop Error modiy Sellorder error #",err);
             return(0);
            }
           }
          }
         }
        }
     //----
    }
  return;
//----
}


//+------------------------------------------------------------------+
//| ffnet Order                                                     |
//+------------------------------------------------------------------+
int CheckForOpen(int typ, double vol, string komtr, int nr)
{
//---- Bei Erfolg Rckgabe 1 sonst 0

 int right, ticket=0, err;
 int Gemacht=0;
 
 while(IsStopped()==false)
 {
 Gemacht++;
 if( ticket>0 ) break;
   if(typ==OP_SELL)
     {
         ticket = OrderSend(Symbol(), OP_SELL, vol, MarketInfo(Symbol(),MODE_BID), OrderSlippage, 0, 0, komtr, nr, 0, Red);
         if (ticket>0) 
             {
              Print("Sell Order #",ticket," opend by ",komtr);
              right=1;
             }
         else
           {
            err=GetLastError();
            Print("Error(",err,") opening Sell ",komtr);
            right=0;
            RefreshRates();
           }
           return(right);
     }
   if(typ==OP_BUY)
     {
            ticket = OrderSend(Symbol(), OP_BUY, vol, MarketInfo(Symbol(),MODE_ASK), OrderSlippage, 0, 0, komtr, nr, 0, Blue);
            if (ticket>0) 
               {
                Print("Buy Order #",ticket," opend by ",komtr);
                right=1;
               }
            else
              {
               err=GetLastError();
               Print("Error(",err,") opening Buy ",komtr);
               right=0;
               RefreshRates();
              }
              return(right);
      }
   Sleep(1000); // 1000 millisekunden = 1 sekunde
   if(Gemacht>7)break;
 }

//----
return(0);
}



//+------------------------------------------------------------------+
//| Schliet Orders                                                  |
//+------------------------------------------------------------------+
int CheckForClose(int Anzahl, int typ)
{
//----Bei Erfolg Rckgabe 1 sonst 0
 int err,funkt;
 int Gemacht=0;
 while(IsStopped()==false)
 {
 Gemacht++;
 if( Anzahl <= 0 ) break;  
   for(int i=0; i<OrdersTotal(); i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==true)
      {
      if(OrderMagicNumber()== Magicnumber)
      {
      //---- check order type 
      if(OrderType()==OP_BUY && typ==OrderType())
        {
         if(OrderClose(OrderTicket(),OrderLots(),MarketInfo(Symbol(),MODE_BID),OrderSlippage,White)) 
           {
            Print("Order #",OrderTicket()," Close by CheckForClose"); 
            funkt=1;
           } 
         else 
           {
            RefreshRates(); 
            err=GetLastError(); 
            Print("Error(",err,") closing Order #",OrderTicket()); 
            funkt=0;
           }
         return(funkt);
        }
      if(OrderType()==OP_SELL && typ==OrderType())
        {
         if(OrderClose(OrderTicket(),OrderLots(),MarketInfo(Symbol(),MODE_ASK),OrderSlippage,White)) 
           {
            Print("Order #",OrderTicket()," Close by CheckforClose"); 
            funkt=1;
           }
         else 
           {
            RefreshRates(); 
            err=GetLastError(); 
            Print("Error(",err,") closing Order #",OrderTicket());
            funkt=0;
           }
         return(funkt);
        }
      }
      }
     }
 Sleep(1000); // 1000 millisekunden = 1 sekunde 
 if(Gemacht>7)break;
 }
//----
return(funkt);
}



//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void SLTKNachreichen(int TK, int SL)
{
//----
for(int cnt=0; cnt < OrdersTotal(); cnt++)
{
 //----
 if(OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES))
  {
   if(OrderType()<=OP_SELL && OrderSymbol()==Symbol() && OrderMagicNumber()==Magicnumber)
    {
     if(OrderType()==OP_BUY)
      {
       if(true)
        {
         if((OrderStopLoss()==0&&SL!=0)||(OrderTakeProfit()==0&&TK!=0))
          {
           if(SL==0)double sl=0; else sl=NormalizeDouble(MarketInfo(Symbol(),MODE_BID)-(Point*SL),Digits);
           if(TK==0)double tk=0; else tk=NormalizeDouble(MarketInfo(Symbol(),MODE_BID)+(Point*TK),Digits);
           OrderModify(OrderTicket(),OrderOpenPrice(),Low[1],tk,0,Green);
           int err = GetLastError();
           if(err != 0)Print("Stoploss und Takprofit nachgereicht Error #",err);
           return(0);
          }
         }
        }
        else
         {
          if(true)
           {
            if((OrderStopLoss()==0&&SL!=0)||(OrderTakeProfit()==0&&TK!=0))
            {
             if(SL==0)sl=0; else sl=NormalizeDouble(MarketInfo(Symbol(),MODE_ASK)+(Point*SL),Digits);
             if(TK==0)tk=0; else tk=NormalizeDouble(MarketInfo(Symbol(),MODE_ASK)-(Point*TK),Digits);
             OrderModify(OrderTicket(),OrderOpenPrice(),High[1],tk,0,Red);
             err = GetLastError();
             if(err != 0)Print("Stoploss und Takprofit nachgereicht Error #",err);
             return(0);
            }
           }
          }
         }
        }
     //----
    }
  return;
//----
}